#include <windows.h>
#include <commctrl.h>

const char lpClassName[] = "PBListView";

HWND hWnd, hListView;
HINSTANCE hInst;

HBRUSH hbr1, hbr2;

char szPercent[101][4];

__declspec(naked) char* __fastcall bnultoa(unsigned int dwnum, char* szdst)
{ // ECX = dwnum, EDX = szdst
  __asm {
    or       ecx, ecx
    jnz      short L1
    lea      eax, [edx+1]
    mov      byte ptr[edx], 48
    mov      byte ptr[eax], cl
    ret      0
 L1:
    mov      [esp-4], edi
    mov      [esp-8], edx
    mov      edi, edx
 L2:
    mov      eax, -858993459
    mul      ecx
    mov      eax, edx
    shr      eax, 3
    mov      edx, ecx
    lea      ecx, [eax+eax*8]
    add      ecx, eax
    sub      edx, ecx
    add      dl, 48
    mov      [edi], dl
    mov      ecx, eax
    inc      edi
    test     eax, eax
    jnz      short L2
    mov      byte ptr[edi], al
    mov      [esp-12], edi
    mov      eax, [esp-8]
 L3:
    dec      edi
    mov      dl, [eax]
    mov      cl, [edi]
    mov      [edi], dl
    mov      [eax], cl
    inc      eax
    cmp      eax, edi
    jb       short L3
    mov      eax, [esp-12]
    mov      edi, [esp-4]
    ret      0
  }
}

LRESULT CALLBACK AppWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
  RECT rect;
  LVCOLUMN lvc;
  LVITEM lvi;
  LPDRAWITEMSTRUCT lpDrawItem;
  int x, y;
  int i;

  switch(uMsg)
  {
  case WM_DRAWITEM: // dessin d'un item, on dessine d'un coup toutes les colonnes
    lpDrawItem = (LPDRAWITEMSTRUCT)lParam;
    // Rcupre le pourcentage qui est dans lParam
    lvi.mask = LVIF_PARAM; // on veut rcuprer lParam
    lvi.iItem = lpDrawItem->itemID; // itemID contient l'index de l'item dans la liste
    ListView_GetItem(hListView, &lvi);

    //FillRect(lpDrawItem->hDC, &lpDrawItem->rcItem, GetStockObject(WHITE_BRUSH));
    if(ListView_GetItemState(hListView, lpDrawItem->itemID, LVIS_SELECTED) & LVIS_SELECTED)
    {
      // L'lment est slctionn
      FillRect(lpDrawItem->hDC, &lpDrawItem->rcItem, GetSysColorBrush(COLOR_HIGHLIGHT));
      SetTextColor(lpDrawItem->hDC, GetSysColor(COLOR_HIGHLIGHTTEXT));
    }
    else
    {
      FillRect(lpDrawItem->hDC, &lpDrawItem->rcItem, GetSysColorBrush(COLOR_WINDOW));
      SetTextColor(lpDrawItem->hDC, GetSysColor(COLOR_MENUTEXT));
    }

    ListView_GetItemRect(hListView, lpDrawItem->itemID, &rect, LVIR_BOUNDS);
    x = rect.left; // x dpend de la position de la scroll bar horizontalle
    // en tous cas on a toujours x <= 0
    rect.top = lpDrawItem->rcItem.top;
    rect.bottom = lpDrawItem->rcItem.bottom;

    // Premire colonne
    y = ListView_GetColumnWidth(hListView, 0);
    rect.left = x + 2;
    rect.right = x + y - 2;
    DrawText(lpDrawItem->hDC, "Mettre du texte ici", 19, &rect, DT_VCENTER);
    x += y;

    // Deuxime colonne
    y = ListView_GetColumnWidth(hListView, 1);
    rect.left = x + 2;
    rect.right = x + y - 2;
    DrawText(lpDrawItem->hDC, szPercent[lvi.lParam], 4, &rect, DT_VCENTER);
    x += y;


    y = ListView_GetColumnWidth(hListView, 2);

    rect.left = x;
    rect.right = x + y;
    rect.top = lpDrawItem->rcItem.top + 1;
    rect.bottom = lpDrawItem->rcItem.bottom - 1;
    FillRect(lpDrawItem->hDC, &rect, (HBRUSH)GetStockObject(BLACK_BRUSH));

    // Dessine de 0  lParam
    rect.left = x + 1;
    i = lvi.lParam * (y - 1) / 100;
    rect.right = x + i + 1;
    rect.top = lpDrawItem->rcItem.top + 2;
    rect.bottom = lpDrawItem->rcItem.bottom - 2;
    if(lvi.lParam)
      FillRect(lpDrawItem->hDC, &rect, hbr1);

    // Dessine de lParam  100
    rect.left = x + i + 1;
    rect.right = x + y - 1;
    if(lvi.lParam != 100)
      FillRect(lpDrawItem->hDC, &rect, hbr2);
    break;
  case WM_CREATE:
    // je mets le style LVS_OWNERDRAWFIXED pour pourvoir dessiner la liste comme je veux
    hListView = CreateWindow(WC_LISTVIEW, 0, LVS_REPORT | WS_VISIBLE | WS_CHILD | LVS_OWNERDRAWFIXED, 
      CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, hWnd, 0, hInst, 0);
    ListView_SetExtendedListViewStyleEx(hListView, 0, LVS_EX_FULLROWSELECT);

    lvc.mask = LVCF_TEXT | LVCF_WIDTH;

    // insre les colonnes
    lvc.cx = 200;
    lvc.pszText = "colonne3";
    ListView_InsertColumn(hListView, 0, &lvc);

    lvc.pszText = "colonne2";
    ListView_InsertColumn(hListView, 0, &lvc);

    lvc.pszText = "colonne1";
    ListView_InsertColumn(hListView, 0, &lvc);

    // insre 100 lignes
    for(i = 0; i < 100; i++)
    {
      LARGE_INTEGER li;
      QueryPerformanceCounter(&li);
      lvi.mask = LVIF_PARAM; 
      lvi.iItem = lvi.iSubItem = 0; 
      // Ici je n'ai qu'une information donc je la mets directement mais s'il y en
      //  plusieurs (par exemple plusieurs progress bar), il suffit de crer une
      // nouvelle structure et de mettre un pointeur sur un structure dans lParam
      lvi.lParam = (LPARAM)(li.LowPart % 101);
      ListView_InsertItem(hListView, &lvi);
    }
    break;
  case WM_ERASEBKGND:
    return 0;
  case WM_SIZE:
    GetClientRect(hWnd, &rect);
    MoveWindow(hListView, 0, 0, rect.right - rect.left, rect.bottom - rect.top, TRUE);
    break;
  case WM_DESTROY:
    PostQuitMessage(0);
    return 0;
  default:
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
  }
  return 0;
}

void __fastcall bnzeromemAL(void *pmem, DWORD len)
{
  BYTE *p = (BYTE*) pmem;
  DWORD r = len;
  if(!(len >>= 3)) goto prepm1SET;
mem8SET:
  *((DWORD*) p) = 0;
  *((DWORD*) (p + 4)) = 0;
  p += 8;
  if(--len) goto mem8SET;
prepm1SET:
  if(!(r &= 7)) goto zeromemEXIT;
mem1SET:
  *p++ = 0;
  if(--r) goto mem1SET;
zeromemEXIT: return;
}

int __stdcall WinMainCRTStartup()
{
  MSG msg;
  WNDCLASSEX wcex;

  for(int i = 0; i <= 100; i++)
  {
    char* p = bnultoa(i, szPercent[i]);
    p[0] = '%';
    p[1] = 0;
  }

  InitCommonControls();


  hbr1 = CreateSolidBrush(RGB(0, 0, 128));
  hbr2 = CreateSolidBrush(RGB(192, 192, 192));

  bnzeromemAL(&wcex, sizeof wcex);
  wcex.cbSize			  = sizeof wcex;
  wcex.style			  = CS_HREDRAW | CS_VREDRAW;
  wcex.lpfnWndProc	= (WNDPROC)AppWndProc;
  wcex.hInstance		= hInst = GetModuleHandle(0);
  wcex.hIcon			  = wcex.hIconSm = LoadIcon(0, IDI_APPLICATION);
  wcex.hCursor		  = LoadCursor(NULL, IDC_ARROW);
  wcex.hbrBackground	= (HBRUSH)COLOR_WINDOW;
  wcex.lpszClassName	= lpClassName;

  if(!RegisterClassEx(&wcex))
    return 0;

  hWnd = CreateWindow(lpClassName, "PBListView", WS_OVERLAPPEDWINDOW,
    CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, 0, hInst, 0);

  ShowWindow(hWnd, SW_SHOW);
  UpdateWindow(hWnd);

  while(GetMessage(&msg, NULL, 0, 0))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }

  DeleteObject(hbr1);
  DeleteObject(hbr2);

  ExitProcess(0);
}